// Written by TeTeT for Nimitz in arma 3

ttt_xmas_fnc_letterFromMan = compileFinal preprocessFile "functions\fn_letterFromMan.sqf";
ttt_xmas_fnc_worldFromMan = compileFinal preprocessFile "functions\fn_worldFromMan.sqf";

/**
[] spawn {
	private _planeType = "JS_JC_FA18E";
	private _pilotType = "JS_JC_PILOT";
	private _d = 50;
	sleep 0.1;
	private _textureClasses = "(getText (_x >> 'displayName')) find 'CAG' > -1" configClasses (configFile >> "CfgVehicles" >> _planeType >> "textureSources");
	// systemChat str (count _textureClasses);
	private _pos = [0,0];
	private _i = 0;
	{
		_pos = player getPos [3000, _forEachIndex * 10];
		_pos set [2, 200 + _forEachIndex * 10];

		private _plane = createVehicle [_planeType, _pos, [], 0, "NONE"];
		_plane setDir (_plane getDir Nimitz);
		_plane setVelocityModelSpace [0,250,0];
		private _agent = createAgent [_pilotType, _pos, [], 0, "NONE"];
		_agent assignAsDriver _plane;
		_agent moveInDriver _plane;
		private _textures = getArray (_x >> "textures");
		// systemChat str _textures;
		{
			_plane setObjectTextureGlobal [_forEachIndex, _x];
		} forEach _textures;


		sleep 0.1;
		_i = _i + 1 mod 4;
	} forEach _textureClasses;
};
**/

[] spawn {
	private _planeType = "JS_JC_FA18E";
	private _pilotType = "JS_JC_PILOT";
	private _d = 100;
	private _vSize = 4;
	private _dForm = 100;
	waitUntil {time > 0};
	sleep 5;
	private _textureClasses = "(getText (_x >> 'displayName')) find 'CAG' > -1" configClasses (configFile >> "CfgVehicles" >> _planeType >> "textureSources");
	// systemChat str (count _textureClasses);
	private _startPos = player getPos [3000, getDir player];
	_startPos set [2, 150];
	private _leadPlane = ObjNull;
	finalPlane = ObjNull;
	private _i = 0;
	{
		// systemChat str _i;
		private _pos = [0, 0, 0];
		if (_i == 0) then {
			// new formation head
			private _distFromStart = _forEachIndex * _dForm;
			_pos = _startPos getPos [_distFromStart, getDir player];

		} else {
			if ((_i mod 2) == 1) then {
				_pos = _leadPlane getPos [ _d * round(_i / 2), getDir _leadPlane + 115];
			} else {
				_pos = _leadPlane getPos [ _d * round(_i / 2), getDir _leadPlane - 115];
			};
		};
		_pos set [2, 150];

		private _plane = createVehicle [_planeType, _pos, [], 0, "FLY"];
		if (isNull _leadPlane) then {
			_plane setDir (_plane getDir player);
		} else {
			_plane setDir (getDir _leadPlane);
		};
		if (_i == 0) then {
			_leadPlane = _plane;
		};

		_plane setVelocityModelSpace [0,250,0];
		private _agent = createAgent [_pilotType, [0,0,0], [], 0, "NONE"];
		_agent assignAsDriver _plane;
		_agent moveInDriver _plane;
		private _textures = getArray (_x >> "textures");
		// systemChat str _textures;
		{
			_plane setObjectTextureGlobal [_forEachIndex, _x];
		} forEach _textures;

		sleep 0.01;
		_i = (_i + 1) mod _vSize;
		_plane forceSpeed (600 * 1000 / 3600);
		finalPlane = _plane;
	} forEach _textureClasses;
};


[] spawn {
	waitUntil {time > 0};
	sleep 5;
	private _pos = player getPos [400, getDir Nimitz - 90];
	_pos set [2, 100];
	private _cam = "camera" camCreate _pos;
	showCinemaBorder false;
	_cam cameraEffect ["internal","back"];
	_cam camSetFov 1;
	_cam camSetTarget player;
	_cam camCommit 0;

	_pos = player getPos [50, getDir Nimitz - 90];
	_pos set [2, 200];
	_cam camSetPos _pos;
	_cam camCommit 5;
	sleep 5;

	_cam camSetPos [getPos _cam # 0, getPos _cam # 1, 300];
	_cam camCommit 10;
	sleep 10;

	sleep 15;
	_cam cameraEffect ["terminate", "back"];
	camDestroy _cam;

};

["merry xmas", getPosWorld start, (getDir Nimitz + 90), 2, "B_mas_usn_officer_shirt_F_an"] spawn ttt_xmas_fnc_worldFromMan;
